#! usr/bin/awk -f


BEGIN{

de = -9999
ctr = 0;

############### Assignment_AA.out ##################################

    i=0
	while (getline < ARGV[1] > 0){
      		i++
      		AA[i] = $1
      		PK2AA[i] = $2
      		reli[i] = $3
      		if (NF<3){reli[i]="-";PK2AA[i]="-";}
      		last_i = i
   	}close (ARGV[1])

############### input chemical shift file read header ##################################

	while (getline < ARGV[2] > 0){
    	if($0 !~/^#/ && NF>1 && (substr($1,1,1)~/[A-Z]/)){
      		if(++ctr==1){Number = NF+1;}
      		for(i=1;i<=NF;i++){
            	if ("N"==$i) col_N=i+1
               	if ("H"==$i || "HN"==$i) col_H=i+1
               	if ("CO"==$i || "C"==$i) col_C=i+1
               	if ("CA"==$i) col_CA=i+1
               	if ("CB"==$i) col_CB=i+1
               	if ("HA"==$i) col_HA=i+1
               	if ("N-1"==$i) col_pN=i+1
               	if ("H-1"==$i || "HN-1"==$i) col_pH=i+1
               	if ("CO-1"==$i || "C-1"==$i) col_pC=i+1
               	if ("CA-1"==$i) col_pCA=i+1
               	if ("CB-1"==$i) col_pCB=i+1
               	if ("HA-1"==$i) col_pHA=i+1
               	if ("N+1"==$i) col_nN=i+1
               	if ("H+1"==$i || "HN+1"==$i) col_nH=i+1
            	
            }
        }
    }close (ARGV[2])

############### Read in chemical shift values ##################################


	while (getline < ARGV[2] > 0){
		if ($1!~/^#/ && NF==Number){
	  		j++
  			pk_id[j] = $1
  			assigned[j] = 0
	  		
			N[j]=de;	pN[j]=de;	nN[j]=de;
			H[j]=de;	pH[j]=de;	nH[j]=de;
			C[j]=de;	pC[j]=de
			CA[j]=de;	pCA[j]=de;
			CB[j]=de;	pCB[j]=de;
			HA[j]=de;	pHA[j]=de;
			
			
			if (col_N>0 && $(col_N)!="-"){ N[j] = $(col_N)}
			if (col_H>0 && $(col_H)!="-"){ H[j] = $(col_H)}
			if (col_C>0 && $(col_C)!="-"){ C[j] = $(col_C)}
			if (col_CA>0 && $(col_CA)!="-"){ CA[j] = $(col_CA)}
			if (col_CB>0 && $(col_CB)!="-"){ CB[j] = $(col_CB)}
			if (col_HA>0 && $(col_HA)!="-"){ HA[j] = $(col_HA)}
			if (col_pN>0 && $(col_pN)!="-"){ pN[j] = $(col_pN)}
			if (col_pH>0 && $(col_pH)!="-"){ pH[j] = $(col_pH)}
			if (col_pC>0 && $(col_pC)!="-"){ pC[j] = $(col_pC)}
			if (col_pCA>0 && $(col_pCA)!="-"){ pCA[j] = $(col_pCA)}
			if (col_pCB>0 && $(col_pCB)!="-"){ pCB[j] = $(col_pCB)}
			if (col_pHA>0 && $(col_pHA)!="-"){ pHA[j] = $(col_pHA)}
			if (col_nN>0 && $(col_nN)!="-"){ nN[j] = $(col_nN)}
			if (col_nH>0 && $(col_nH)!="-"){ nH[j] = $(col_nH)}
			
			last_j = j
		}
	}close (ARGV[2])

############### Print out header ##################################

	assigned_output = ("./assigned_peaks_res-tmp.out")

    printf "%-8s","RES" > assigned_output
    printf "%-20s", "peak_id" >> assigned_output
    printf "%5s","reli" >> assigned_output  

 	if(col_N>0)printf "%14s","N"  >> assigned_output  
 	if(col_H>0)printf "%14s","HN"  >> assigned_output
 	if(col_C>0)printf "%14s","CO"  >> assigned_output
 	if(col_CA>0)printf "%14s","CA"  >> assigned_output
 	if(col_CB>0)printf "%14s","CB"  >> assigned_output
 	if(col_HA>0)printf "%14s","HA"  >> assigned_output

 	if(col_pN>0)printf "%14s","N-1"  >> assigned_output
 	if(col_pH>0)printf "%14s","HN-1"  >> assigned_output
 	if(col_pC>0)printf "%14s","CO-1"  >> assigned_output
 	if(col_pCA>0)printf "%14s","CA-1"  >> assigned_output
 	if(col_pCB>0)printf "%14s","CB-1"  >> assigned_output
 	if(col_pHA>0)printf "%14s","HA-1"  >> assigned_output
 	
 	if(col_nN>0)printf "%14s","N+1"  >> assigned_output
 	if(col_nH>0)printf "%14s","HN+1"  >> assigned_output

	printf "\n"   >> assigned_output
	
############### Print out chemical shfits with assignment #############

    for (x=1;x<=last_i;x++){
    	if (PK2AA[x]=="-"){
      		if (col_N>0) { n[x]  = de }
			if (col_H>0) { h[x]  = de }
			if (col_C>0) { co[x] = de }
			if (col_CA>0) { ca[x] = de }
			if (col_CB>0) { cb[x] = de }
			if (col_HA>0) { ha[x] = de }
			if (col_pN>0) { pn[x] = de }
			if (col_pH>0) { ph[x] = de }
			if (col_pC>0) { pco[x] = de }
			if (col_pCA>0) { pca[x] = de }
			if (col_pCB>0) { pcb[x] = de }
			if (col_pHA>0) { pha[x] = de }
			if (col_nN>0) { nn[x] = de }
			if (col_nH>0) { nh[x] = de }
		}
      	else{
      		for(y=1;y<=last_j;y++){
				if (PK2AA[x] == pk_id[y]){
					assigned[y]++
							
					if (col_N>0 && N[y]!="-") { n[x]  = N[y] }
					if (col_H>0 && H[y]!="-") { h[x]  = H[y] }
					if (col_C>0 && C[y]!="-") { co[x] = C[y] }
					if (col_CA>0 && CA[y]!="-") { ca[x] = CA[y] }
					if (col_CB>0 && CB[y]!="-") { cb[x] = CB[y] }
					if (col_HA>0 && HA[y]!="-") { ha[x] = HA[y] }
					if (col_pN>0 && pN[y]!="-") { pn[x] = pN[y] }
					if (col_pH>0 && pH[y]!="-") { ph[x] = pH[y] }
					if (col_pC>0 && pC[y]!="-") { pco[x] = pC[y] }
					if (col_pCA>0 && pCA[y]!="-") { pca[x] = pCA[y] }
					if (col_pCB>0 && pCB[y]!="-") { pcb[x] = pCB[y] }
					if (col_pHA>0 && pHA[y]!="-") { pha[x] = pHA[y] }
					if (col_nN>0 && nN[y]!="-") { nn[x] = nN[y] }
					if (col_nH>0 && nH[y]!="-") { nh[x] = nH[y] }

				}
			}
		}
			
		printf "%-8s",AA[x] >> assigned_output
		printf "%-20s", PK2AA[x] >> assigned_output
		printf "%5s",reli[x] >> assigned_output  

		if(col_N>0)printf "%14.5f", n[x]  >> assigned_output  
		if(col_H>0)printf "%14.5f", h[x]  >> assigned_output
		if(col_C>0)printf "%14.5f", co[x]  >> assigned_output
		if(col_CA>0)printf "%14.5f", ca[x]  >> assigned_output
		if(col_CB>0)printf "%14.5f", cb[x]  >> assigned_output
		if(col_HA>0)printf "%14.5f", ha[x]  >> assigned_output
		if(col_pN>0)printf "%14.5f", pn[x]  >> assigned_output
		if(col_pH>0)printf "%14.5f", ph[x]  >> assigned_output
		if(col_pC>0)printf "%14.5f", pco[x]  >> assigned_output
		if(col_pCA>0)printf "%14.5f", pca[x]  >> assigned_output
		if(col_pCB>0)printf "%14.5f", pcb[x]  >> assigned_output
		if(col_pHA>0)printf "%14.5f", pha[x]  >> assigned_output
		if(col_nN>0)if(x!=last_i){printf "%14.5f", nn[x] >> assigned_output}else{printf "%14.5f", de >> assigned_output}  
		if(col_nH>0)if(x!=last_i){printf "%14.5f", nh[x] >> assigned_output}else{printf "%14.5f", de >> assigned_output}  

		printf "\n"   >> assigned_output
	}
	
############### Print out unassigned peak list  #############

	not_assigned_output = ("./unassigned_peaks-tmp.list")

	printf "### The following are the peaks that could not be assigned.\n" > not_assigned_output

    while (getline < ARGV[2] > 0){
		if ($1~/#/){ 
	  		print $0 >> not_assigned_output 
	  	}
	}close (ARGV[2])

    printf "%-20s","pks" >> not_assigned_output
	
	if(col_N>0)printf "%14s","N"  >> not_assigned_output  
	if(col_H>0)printf "%14s","HN"  >> not_assigned_output
	if(col_C>0)printf "%14s","CO"  >> not_assigned_output
	if(col_CA>0)printf "%14s","CA"  >> not_assigned_output
	if(col_CB>0)printf "%14s","CB"  >> not_assigned_output
	if(col_HA>0)printf "%14s","HA"  >> not_assigned_output
	if(col_pN>0)printf "%14s","N-1"  >> not_assigned_output
	if(col_pH>0)printf "%14s","HN-1"  >> not_assigned_output
	if(col_pC>0)printf "%14s","CO-1"  >> not_assigned_output
	if(col_pCA>0)printf "%14s","CA-1"  >> not_assigned_output
	if(col_pCB>0)printf "%14s","CB-1"  >> not_assigned_output
	if(col_pHA>0)printf "%14s","HA-1"  >> not_assigned_output
	if(col_nN>0)printf "%14s","N+1"  >> not_assigned_output
	if(col_nH>0)printf "%14s","HN+1"  >> not_assigned_output
	
	printf "\n"   >> not_assigned_output
    
	for(y=1;y<=last_j;y++){
		if (!assigned[y]){
			
			printf "%-20s",pk_id[y] >> not_assigned_output
			if(col_N>0)printf "%14.5f", N[y]  >> not_assigned_output  
			if(col_H>0)printf "%14.5f", H[y]  >> not_assigned_output
			if(col_C>0)printf "%14.5f", C[y]  >> not_assigned_output
			if(col_CA>0)printf "%14.5f", CA[y]  >> not_assigned_output
			if(col_CB>0)printf "%14.5f", CB[y]  >> not_assigned_output
			if(col_HA>0)printf "%14.5f", HA[y]  >> not_assigned_output
			if(col_pN>0)printf "%14.5f", pN[y]  >> not_assigned_output
			if(col_pH>0)printf "%14.5f", pH[y]  >> not_assigned_output
			if(col_pC>0)printf "%14.5f", pC[y]  >> not_assigned_output
			if(col_pCA>0)printf "%14.5f", pCA[y]  >> not_assigned_output
			if(col_pCB>0)printf "%14.5f", pCB[y]  >> not_assigned_output
			if(col_pHA>0)printf "%14.5f", pHA[y]  >> not_assigned_output
			if(col_nN>0)printf "%14.5f", nN[y]  >> not_assigned_output
			if(col_nH>0)printf "%14.5f", nH[y]  >> not_assigned_output
			
			printf "\n"   >> not_assigned_output
		}
	}
	
	
	delete pk_id
	delete N ; delete n ;
	delete H ; delete h ;
	delete C ; delete co ;
	delete CA ; delete ca ;
	delete CB ; delete cb ;
	delete HA ; delete ha ;
	delete pN ; delete pn ;
	delete pH ; delete ph ;
	delete pC ; delete pco ;
	delete pCA ; delete pca ;
	delete pCB ; delete pcb ;
	delete pHA ; delete pha ;
	delete nN ; delete nn ;
	delete nH ; delete nh ;

  	com = sprintf ("sed 's/-9999.00000/          -/g' %s > assigned_peaks_res.out", assigned_output)
 	print | com
 	close (com)

  	com = sprintf ("sed 's/-9999.00000/          -/g' %s > unassigned_peaks.list", not_assigned_output)
 	print | com
 	close (com)
 	
 	com = sprintf ("rm -rf %s %s", assigned_output, not_assigned_output)
 	print | com
 	close (com)
}
